import java.awt.*;

class DrawingEntityPlain
{
    public EntityAirPlane Airplane;

    private float _startPosX;
    private float _startPosY;

    private int _pictureWidth = -1;
    private int _pictureHeight = -1;

    private int _AirplaneWidth = 120;
    private int _AirplaneHeight = 60;

    public void Init(int speed, float weight, Color bodyColor)
    {
        Airplane = new EntityAirPlane();
        Airplane.Init(speed, weight, bodyColor);
    }

    public void SetPosition(int x, int y, int width, int height)
    {
        if (width < _AirplaneWidth || height < _AirplaneHeight) return;

        if (x + _AirplaneWidth > width || x < 0) return;
        if (y + _AirplaneHeight > height || y < 0) return;

        _startPosX = x;
        _startPosY = y;

        _pictureWidth = width;
        _pictureHeight = height;
    }

    public void MoveTransport(Direction direction)
    {
        if (_pictureWidth == -1 || _pictureHeight == -1)
        {
            return;
        }


        switch (direction)
        {
            case Right:
                if (_startPosX + _AirplaneWidth + Airplane.Step < _pictureWidth)
                {
                    _startPosX += Airplane.Step;
                }
                break;
            case Left:
                if (_startPosX - Airplane.Step > 0)
                {
                    _startPosX -= Airplane.Step;
                }
                break;
            case Up:
                if (_startPosY - Airplane.Step > 0)
                {
                    _startPosY -= Airplane.Step;
                }
                break;
            case Down:
                if (_startPosY + _AirplaneHeight + Airplane.Step < _pictureHeight)
                {
                    _startPosY += Airplane.Step;
                }
                break;
        }

    }

    public void DrawTransport(Graphics2D g)
    {
        if (_pictureWidth == -1 || _pictureHeight == -1)
        {
            return;
        }


        g.drawRect( (int)_startPosX, (int)_startPosY, 20, 30);
        g.drawRect( (int)_startPosX, (int)_startPosY + 30, 100, 30);
        g.drawRect( (int)_startPosX+100, (int)_startPosY + 40, 20, 15);
        //koleso1
        g.drawRect( (int)_startPosX + 30, (int)_startPosY + 60, 5, 10);
        g.drawOval( (int)_startPosX+28,(int) _startPosY+70, 9, 9);
        //koleso2
        g.drawRect( (int)_startPosX + 80, (int)_startPosY + 60, 5, 10);
        g.drawOval( (int)_startPosX + 78, (int)_startPosY + 70, 9, 9);

        //Korpys
        g.setPaint(Airplane.BodyColor);
        g.fillRect((int)_startPosX+3, (int)_startPosY + 33, 94, 24);
        g.fillRect( (int)_startPosX+1, (int)_startPosY+1, 19, 29);

        //krilya
        g.setPaint(Color.black);
        g.fillRect((int)_startPosX + 30, (int)_startPosY + 40, 40, 8);

        //cabina
        g.setPaint(Color.blue);
        g.fillRect( (int)_startPosX + 101, (int)_startPosY + 41, 19, 14);

    }

    public void ChangeBorders(int width, int height)
    {
        _pictureWidth = width;
        _pictureHeight = height;
        if (_pictureWidth <= _AirplaneWidth || _pictureHeight <= _AirplaneHeight)
        {
            _pictureWidth = -1;
            _pictureHeight = -1;
            return;
        }
        if (_startPosX + _AirplaneWidth > _pictureWidth)
        {
            _startPosX = _pictureWidth - _AirplaneWidth;
        }
        if (_startPosY + _AirplaneHeight > _pictureHeight)
        {
            _startPosY = _pictureHeight - _AirplaneHeight;
        }
    }

}