import javax.swing.*;
import javax.swing.border.LineBorder;
import java.awt.*;
import java.awt.event.ComponentAdapter;
import java.awt.event.ComponentEvent;
import java.util.Random;

public class FormAirPlane {
    private JButton createButton;
    private JButton upButton;
    private JButton rightButton;
    private JButton downButton;
    private JButton leftButton;
    private JPanel mainPanel;
    private JPanel DrawPlace;
    private JLabel speedLabel;
    private JLabel weightLabel;
    private JLabel colorLabel;

    DrawingEntityPlain _airPlane;


    private JFrame jframe = getFrame();

    private JFrame getFrame() {
        JFrame frame = new JFrame();
        frame.setVisible(true);
        frame.setBounds(300, 100, 800, 600);
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        return frame;
    }

    public void run() {
        jframe.add(mainPanel);
        Canvas canv = new Canvas(this);
        DrawPlace.add(canv);


        createButton.addActionListener(e -> {
            Dimension canvSize = canv.getSize();
            Random rnd = new Random();

            _airPlane = new DrawingEntityPlain();

            _airPlane.Init(rnd.nextInt(100, 300), rnd.nextInt(1000, 2000),
                    new Color(rnd.nextInt(0, 256), rnd.nextInt(0, 256), rnd.nextInt(0, 256)));

            _airPlane.SetPosition((int)rnd.nextInt(10, 100), (int)rnd.nextInt(10, 100), canvSize.width, canvSize.height);

            Color bodyColor = _airPlane.Airplane.BodyColor;
            String colorString = "(" + bodyColor.getRed() + ", " + bodyColor.getGreen() + ", " + bodyColor.getBlue() + ")";

            speedLabel.setText("Скорость: " + _airPlane.Airplane.Speed + "   ");
            weightLabel.setText("Вес: " + _airPlane.Airplane.Weight + "   ");
            colorLabel.setText("Цвет: " + colorString);

            canv.repaint();
        });

        jframe.addComponentListener(new ComponentAdapter() {
            @Override
            public void componentResized(ComponentEvent e) {
                if(_airPlane == null) return;
                _airPlane.ChangeBorders(canv.getSize().width, canv.getSize().height);
                jframe.revalidate();
            }
        });

        upButton.addActionListener(e -> {
            if(_airPlane == null) return;
            _airPlane.MoveTransport(Direction.Up);
            canv.repaint();
        });
        rightButton.addActionListener(e -> {
            if(_airPlane == null) return;
            _airPlane.MoveTransport(Direction.Right);
            canv.repaint();
        });
        downButton.addActionListener(e -> {
            if(_airPlane == null) return;
            _airPlane.MoveTransport(Direction.Down);
            canv.repaint();
        });
        leftButton.addActionListener(e -> {
            if(_airPlane == null) return;
            _airPlane.MoveTransport(Direction.Left);
            canv.repaint();
        });
    }

    public void draw(Graphics2D g) {
        if(_airPlane == null) return;
        _airPlane.DrawTransport(g);
    }
}